      program ROBCOOP4A_GR
      parameter(MLABS=2000,MBATCH=10,MREP=5) 
      real data(MLABS,MBATCH,MREP),batch(MLABS,MREP)
      real dataln(MLABS,MBATCH,MREP),batchln(MLABS,MREP)
      real labs(MLABS),labsln(MLABS),wlab(MLABS),wbatch(MLABS,MBATCH), 
     &wrep(MLABS,MBATCH,MREP),ws(6000) 
      real msl,msb,mse,median,mslln,msbln,mseln
      CHARACTER DUM*1,FIELD*18,ELEM*8,NAMEP*25,NAMEX*25
      CHARACTER SAMPLE*32,CFTEXT*19
      CHARACTER*1 AF(18),FF(19),E1(20),AF1(10501),AF2(10501),FF2(20)
      CHARACTER*40 AFILE
      DIMENSION A2(2000,500,4),IKOMA(501),A2LN(2000,500,4)
      
      data c,beta,en /1.5,0.7785,2.718281828459/ 
C     789012345678901234567890123456789012345678901234567890123456789012      
      WRITE(*,'("       ENTER")')
      READ(*,'(A40)') AFILE
      
      WRITE(*,'("      ENTER")')
      READ(*,*) CF
      
      WRITE(*,'("      ENTER")')
      READ(*,*) CL
            
      WRITE(*,*) '           '
      WRITE(*,*) '           '
      WRITE(*,*) '           '
      WRITE(*,*) '            '
      WRITE(*,*) '           '
      WRITE(*,*) '           '
      WRITE(*,*) '           '

      OPEN(8,FILE=AFILE) 

      READ(8,'(10501A1)') (AF1(K),K=1,10501)
      NCOL=0.
      
      DO ICL=1,10501
       IF(AF1(ICL).EQ.',') NCOL=NCOL+1.
      END DO
      
      NCOL=NCOL-1
      ISAM=0

  510 READ(8,'(A1)',END=520) DUM
       ISAM=ISAM+1
      GO TO 510
      
  520 IF(MOD(ISAM,4).NE.0) THEN
       WRITE(*,1001)
       WRITE(*,1002)
       WRITE(*,1003)
       WRITE(*,1004)
       WRITE(*,*)
       WRITE(*,1005)
       READ(*,*)
       STOP
      END IF
      
 1001 FORMAT ('       ')
 1002 FORMAT ('          
     &   4')
 1003 FORMAT ('         
     & ')
 1004 FORMAT ('   ')
 1005 FORMAT ('..... ENTER   .....')
      
      NSAMPLE=ISAM/4
      
C**************************************
      
      ND=2000
      MD=500
      
      REWIND(8)

      OPEN(2,FILE='ANOV.TXT')
      OPEN(22,FILE='ANOVLN.TXT')
      
      READ(8,'(10501A1)') (AF2(K),K=1,10501)
      NPI=0
      
      DO ICL=1,10501
       IF(AF2(ICL).EQ.',') THEN
        NPI=NPI+1
        IKOMA(NPI)=ICL
       END IF
      END DO

      NROW=NSAMPLE*4

      IF(NROW.GT.ND) NROW=ND

      CALL READE(A2,A2LN,NSAMPLE,NCOL,ND,MD)    
                   
      CALL PRINTF(AF2,FF2,NCOL,IKOMA)

      CALL PRINTE(A2,A2LN,NSAMPLE,NCOL,ND,MD,AF2,IKOMA)
      
      CLOSE (2)
      CLOSE (22)
      CLOSE (8)

C**************************************
C**************************************

      E1(1)='_'
      E1(2)='R'
      E1(3)='A'
      E1(4)='N'
      E1(5)='O'
      E1(6)='V'
      E1(7)='A'
      E1(8)='%'
      E1(9)='"'
      E1(10)=','
      E1(11)='"'
      E1(12)='V'
      E1(13)='a'
      E1(14)='r'
      E1(15)='i'
      E1(16)='a'
      E1(17)='n'
      E1(18)='c'
      E1(19)='e'
      E1(20)='"'
      
      OPEN(10,FILE='FILETP.CTL')      
      
      ELEM=''
      SAMPLE='    '
      CFTEXT=' '
      
      NLABS=NSAMPLE
      NB=NCOL
      
      NBATCH=2
      NREPS=2

      OPEN(1,FILE='ANOV.TXT')
      OPEN(11,FILE='ANOVLN.TXT')
      open (2,file='resultsX.txt') 

      do 900 ib = 1,nb 

      READ(1,'(A18)') field
      READ(11,'(A1)') dum
      
      READ(field,'(18A1)') (AF(K),K=1,18)
      
      FF(1)='"'
      NCF=1
      DO I=1,18
       IF(AF(I).EQ.'"'.OR.AF(I).EQ.' ') GO TO 5
       NCF=NCF+1
       FF(NCF)=AF(I)
    5 END DO 

      READ(10,'(A25)') NAMEX
      READ(10,'(A25)') NAMEP

      OPEN(7,FILE=NAMEX)
      OPEN(8,FILE=NAMEP)
      
      WRITE (2,'(A8,A18)') elem,field
      WRITE (2,'(A32,a,I4)') sample,'"',nsample
      WRITE (2,'(A19,a,F4.2)') cftext,'"',cf
      WRITE (7,'(A8,A18)') elem,field
      WRITE (7,'(A32,a,I4)') sample,'"',nsample
      WRITE (7,'(A19,a,F4.2)') cftext,'"',cf
      
      do 10 i = 1,nlabs 
      read (1,*) ((data(i,j,k),k=1,nreps),j=1,nbatch)
   10 read (11,*) ((dataln(i,j,k),k=1,nreps),j=1,nbatch) 
      do 20 i = 1,nlabs 
      do 20 j = 1,nbatch 
      a = 0.0 
      aln = 0.0
      do 15 k = 1,nreps 
      a = a+data(i,j,k) 
   15 aln = aln+dataln(i,j,k) 
      batch(i,j) = a/nreps
   20 batchln(i,j) = aln/nreps 
      do 30 i = 1 ,nlabs 
      a = 0.0 
      aln = 0.0
      do 25 j = 1,nbatch 
      a = a+batch(i,j) 
   25 aln = aln+batchln(i,j) 
      labs(i) = a/nbatch 
   30 labsln(i) = aln/nbatch 
      a = 0.0 
      aln = 0.0
      do 40 i = 1,nlabs 
      a = a+labs(i) 
   40 aln = aln+labsln(i) 
      ybar = a/nlabs 
      ybarln = aln/nlabs 
      
      write(2,'(a)') '__________________________________________________
     &_______________________________'
      write (2,'(a)') '   (ANOVA)'
      write(7,'(a)') '__________________________________________________
     &_______________________________'
      write (7,'(a)') '   (ANOVA)'
C      write (2,*) 'Classical results: Mean = ',ybar 
      s = 0.0 
      sln = 0.0 
      do 50 i = 1,nlabs 
      s = s+(labs(i)-ybar)**2 
   50 sln = sln+(labsln(i)-ybarln)**2 
      ssl = s*nreps*nbatch 
      sslln = sln*nreps*nbatch 
      s = 0.0 
      sln = 0.0 
      do 60 i = 1,nlabs 
      do 60 j = 1,nbatch 
      s = s+(batch(i,j)-labs(i))**2 
   60 sln = sln+(batchln(i,j)-labsln(i))**2 
      ssb = s*nreps 
      ssbln = sln*nreps 
      s = 0.0 
      sln = 0.0 
      do 70 i = 1,nlabs 
      do 70 j = 1,nbatch 
      do 70 k = 1,nreps 
      s = s+(data(i,j,k)-batch(i,j))**2 
   70 sln = sln+(dataln(i,j,k)-batchln(i,j))**2 
      sse = s 
      sseln = sln 
      
      WRITE(2,*) '"""""'
      WRITE(7,*) '"""""'

      write (2,'(a,3(a,f15.6))') ' ','"',ssl,'"',
     &ssb,'"',sse 
      write (7,'(a,3(a,f15.6))') ' ','"',ssl,'"',
     &ssb,'"',sse 

      msl = ssl/(nlabs-1) 
      mslln = sslln/(nlabs-1) 
      msb = ssb/((nbatch-1)*nlabs) 
      msbln = ssbln/((nbatch-1)*nlabs) 
      mse = sse/((nreps-1)*nbatch*nlabs) 
      mseln = sseln/((nreps-1)*nbatch*nlabs) 
      se = sqrt(mse) 
      seln = sqrt(mseln) 
      a = max(0.0,msb-mse)/nreps 
      aln = max(0.0,msbln-mseln)/nreps 
      sb = sqrt(a) 
      sbln = sqrt(aln) 
      a = max(0.0,msl-msb)/(nreps*nbatch) 
      aln = max(0.0,mslln-msbln)/(nreps*nbatch) 
      sl = sqrt(a) 
      slln = sqrt(aln) 
      
      sm=sb**2+se**2
      smln=sbln**2+seln**2
      smo=sqrt(sm)
      smoln=sqrt(smln)
      
C      write(*,*) sm,smo
C      read(*,*)
      
      write(2,'(a,4(a,f15.6))') '  (+/-)','"',sl,
     &'"',sb,'"',se,'"',smo
      write(7,'(a,4(a,f15.6))') '  (+/-)','"',sl,
     &'"',sb,'"',se,'"',smo
      
      WRITE(2,'(a,4(a,f15.7))') '','"',sl**2,'"',sb**2,'"',
     &se**2,'"',sm
      WRITE(7,'(a,4(a,f15.7))') '','"',sl**2,'"',sb**2,'"',
     &se**2,'"',sm
     
      sr = (sl*sl+sb*sb+se*se) 
      srln = (slln*slln+sbln*sbln+seln*seln) 
      
      smp=sb*sb/sr*100+se*se/sr*100
      smpln=sbln*sbln/srln*100+seln*seln/srln*100

      write(2,'(a,4(a,f15.6))') '%   ','"'
     &,sl*sl/sr*100,'"',sb*sb/sr*100,'"',se*se/sr*100,'"',smp
      write(7,'(a,4(a,f15.6))') '%   ','"'
     &,sl*sl/sr*100,'"',sb*sb/sr*100,'"',se*se/sr*100,'"',smp
      
      write(2,'(a,f5.2,a,3(a,f15.6))') '   
     & ',cl,'%   ','""',
     &((sqrt(sb**2)*cf)*100)/ybar,'"',((sqrt(se**2)*cf)*100)/ybar,'"',
     &((sqrt(sb**2+se**2)*cf)*100)/ybar
      write(7,'(a,f5.2,a,3(a,f15.6))') '   
     & ',cl,'%   ','""',
     &((sqrt(sb**2)*cf)*100)/ybar,'"',((sqrt(se**2)*cf)*100)/ybar,'"',
     &((sqrt(sb**2+se**2)*cf)*100)/ybar

      write(2,'(a,f5.2,a,3(a,f15.6))') '  
     &  ',cl,'%   ','""',en**(sbln*cf),'"',
     &en**(seln*cf),'"',en**(smoln*cf)
      write(7,'(a,f5.2,a,3(a,f15.6))') '  
     &  ',cl,'%   ','""',en**(sbln*cf),'"',
     &en**(seln*cf),'"',en**(smoln*cf)
            
      write(2,'(a,f15.6)') ' "',ybar 
      write(7,'(a,f15.6)') ' "',ybar 
      
      sr=sqrt(sr) 
      
      write(2,'(a,f15.6)') '   (+/-)"',sr   
      write(7,'(a,f15.6)') '   (+/-)"',sr   

      write(2,'(a)') '__________________________________________________
     &_______________________________'
      write (2,'(a)') '   (RANOVA)' 
      write(7,'(a)') '__________________________________________________
     &_______________________________'
      write (7,'(a)') '   (RANOVA)' 

C do reps 

      l = 0 
      do 100 i = 1,nlabs 
      do 100 j = 1,nbatch 
      do 100 k = 1,nreps 
      l = l+1 
  100 ws(l) = abs(data(i,j,k)-batch(i,j)) 
      as = median(ws,nlabs*nbatch*nreps) 
      if (as .le. 0.0) as = sqrt(mse) 
      c1 = c*sqrt((nreps-1.0)/nreps) 
  110 as1 = as 
      sum2 = 0.0 
      do 130 i = 1,nlabs 
      do 130 j = 1,nbatch 
      wbatch(i,j) = 0.0 
      do 130 k = 1,nreps 
      wrep(i,j,k) = 
     & max(-c1*as,min(c1*as,data(i,j,k)-batch(i,j))) 
      wbatch(i,j) = wbatch(i,j)+wrep(i,j,k) 
  130 sum2 = sum2+wrep(i,j,k)**2 
      as = sqrt(sum2/(beta*(nreps-1)*nbatch*nlabs)) 
      do 140 i = 1,nlabs 
      do 140 j = 1,nbatch 
  140 batch(i,j) = batch(i,j) + wbatch(i,j)/nreps 
      if (as1 .ne. as) go to 110 
      mse = as*as
C now do batches 
      do 210 i = 1,nlabs 
      do 200 j = 1,nbatch 
  200 ws(j) = batch(i,j) 
  210 labs(i) = median(ws,nbatch) 
      do 220 i = 1,nlabs 
      do 220 j = 1,nbatch 
  220 ws(j+(i-1)*nbatch) = abs(batch(i,j)-labs(i)) 
      as = 1.483*median(ws,nlabs*nbatch) 
      if (as .le. 0.0) as = sqrt(msb/nreps) 
      c2 = c*sqrt((nbatch-1.0)/nbatch) 
  230 as1 = as 
      sum2 = 0.0 
      do 250 i = 1,nlabs 
      wlab(i) = 0.0 
      do 250 j = 1,nbatch 
      wbatch(i,j) = max(-c2*as,min(c2*as,batch(i,j)-labs(i))) 
      wlab(i) = wlab(i)+wbatch(i,j) 
      sum2 = sum2+wbatch(i,j)**2 
  250 continue 
      do 260 i = 1,nlabs 
  260 labs(i) = labs(i)+wlab(i)/nbatch 
      as = sqrt(sum2/(beta*nlabs*(nbatch-1))) 
C      write(*,*) as1,as
      if (as1 .ne. as) goto 230 
      msb = nreps*as*as
C now do labs 
      am = median(labs,nlabs) 
      do 300 i = 1,nlabs 
  300 ws(i) = abs(labs(i)-am) 
      as = 1.483*median(ws,nlabs) 
      if (as .le. 0.0) as = sqrt(msl/(nreps*nbatch)) 
      c3 = c*sqrt((nlabs-1.0)/nlabs) 
  310 as1 = as 
      sum1 = 0.0 
      sum2 = 0.0 
      do 320 i = 1,nlabs 
      wlab(i) = max(-c3*as,min(c3*as,labs(i)-am)) 
      sum1 = sum1+wlab(i) 
      sum2 = sum2+wlab(i)**2 
  320 continue 
      as = sqrt(sum2/(beta*(nlabs-1))) 
      am = am +sum1/nlabs 
      if(abs(as-as1)/as.lt.1e-7)as1=as 
C      write(*,*) as1,as
      if (as .ne. as1) go to 310 
      msl = as*as*nreps*nbatch 
C      write (2,*) 'mean = ',am
      se = sqrt(mse) 
      a = max(0.0,msb-mse)/nreps 
      sb = sqrt(a) 
      a = max(0.0,msl-msb)/(nreps*nbatch) 
      sl = sqrt(a) 
      
      sm=sb**2+se**2
      smo=sqrt(sm)
      
      WRITE(2,*) '"""""'
      WRITE(7,*) '"""""'
      
      write(2,'(a,4(a,f15.6))') '  (+/-)','"',sl,
     &'"',sb,'"',se,'"',smo
      write(7,'(a,4(a,f15.6))') '  (+/-)','"',sl,
     &'"',sb,'"',se,'"',smo

      WRITE(2,'(a,4(a,f15.7))') '','"',sl**2,'"',sb**2,'"',
     &se**2,'"',sm
      WRITE(7,'(a,4(a,f15.7))') '','"',sl**2,'"',sb**2,'"',
     &se**2,'"',sm
     
      sr = (sl*sl+sb*sb+se*se) 
      
      smp=sb*sb/sr*100+se*se/sr*100
      
      write(2,'(a,4(a,f15.6))') '%   ','"',
     &sl*sl/sr*100,'"',sb*sb/sr*100,'"',se*se/sr*100,'"',smp
      write(7,'(a,4(a,f15.6))') '%   ','"',
     &sl*sl/sr*100,'"',sb*sb/sr*100,'"',se*se/sr*100,'"',smp

      write(2,'(a,f5.2,a,3(a,f15.6))') '   
     & ',cl,'%   ','""',((sqrt(sb**2)*cf)*100)/
     &am,'"',((sqrt(se**2)*cf)*100)/am,'"',((sqrt(sb**2+se**2)*cf)*100)/
     &am
      write(7,'(a,f5.2,a,3(a,f15.6))') '   
     & ',cl,'%   ','""',((sqrt(sb**2)*cf)*100)/
     &am,'"',((sqrt(se**2)*cf)*100)/am,'"',((sqrt(sb**2+se**2)*cf)*100)/
     &am
            
      WRITE(8,'(19A1,20A1)') (FF(K),K=1,NCF),(E1(N),N=1,20)
      write(8,'(f9.6,a)') sl*sl/sr*100,',""'
      write(8,'(f9.6,a)') sb*sb/sr*100,',""'
      write(8,'(f9.6,a)') se*se/sr*100,',""'

      write(2,'(a,f15.6)') ' "',am
      write(7,'(a,f15.6)') ' "',am
      
      sr=sqrt(sr) 

      write(2,'(a,f15.6)') '   (+/-)"',sr 
      write(7,'(a,f15.6)') '   (+/-)"',sr 

      WRITE(2,'(a,f15.6)') ', u,   "',
     &sqrt(sb**2+se**2)
      WRITE(7,'(a,f15.6)') ', u,   "',
     &sqrt(sb**2+se**2)

      WRITE(2,'(a,f5.2,a,f15.6)') ' , eu,   
     &  ',cl,'%   "',cf*sqrt(sb**2+se**2)
      WRITE(7,'(a,f5.2,a,f15.6)') ' , eu,   
     &  ',cl,'%   "',cf*sqrt(sb**2+se**2)

      WRITE(2,'(a,f5.2,a,f15.6)') '  , eu%, 
     &    ',cl,'%   "',
     &cf*100.*sqrt(sb**2+se**2)/am
      WRITE(7,'(a,f5.2,a,f15.6)') '  , eu%, 
     &    ',cl,'%   "',
     &cf*100.*sqrt(sb**2+se**2)/am
            
      WRITE(2,'(a,f15.6)') ', U,     
     &   "',sqrt(sb**2+se**2)/
     &1.4142135
      WRITE(7,'(a,f15.6)') ', U,     
     &   "',sqrt(sb**2+se**2)/
     &1.4142135

      WRITE(2,'(a,f5.2,a,f15.6)') '   
     &, eU%,  ',cl,'%   "',
     &cf*100.*(sqrt(sb**2+se**2)/1.4142135)/am
      WRITE(7,'(a,f5.2,a,f15.6)') '   
     &, eU%,  ',cl,'%   "',
     &cf*100.*(sqrt(sb**2+se**2)/1.4142135)/am
      
      write (2,*) 
      write(2,'(a)') '**************************************************
     &*******************************'

      CLOSE (7)
      CLOSE (8)
      
  900 continue 
      close (1) 
      close (11) 
      
      close (2)
      CLOSE (10)
      end
      
      real function median(array,n)
      real array(n),ws(6000) 
      ws(1) = array(1) 
      do 100 i = 2,n 
      tmp = array(i) 
      j = 1 
   10 if (ws(j).lt. tmp) then 
      j = j+1 
      if (j .lt. i) goto 10 
      else 
      do 20 k = i,j+1,-1 
   20 ws(k) = ws(k-1) 
      endif 
      ws(j) = tmp 
  100 continue 
      n2 = n/2 
      if (2*n2 .eq. n) then 
      median = 0.5*(ws(n2)+ws(n2+1)) 
      else 
      median = ws(n2+1) 
      endif 
      
      end
      
C***********************************************************************
C***********************************************************************

      SUBROUTINE READE(A,ALN,NSAMPLE,NCOL,ND,MD)

      DIMENSION A(ND,MD,4),ALN(ND,MD,4)
      DATA NIN/8/
            
      DO I=1,NSAMPLE
       DO K=1,4
        READ(NIN,*) (A(I,J,K),J=1,NCOL+1)

C          
        DO J=1,NCOL
         ALN(I,J,K)=LOG(A(I,J,K))
        END DO
C     **************************************
       END DO
      END DO
      
C              
C        .
      DO I=1,NSAMPLE
             
       DO K=2,4
       
        IF(A(I,NCOL+1,K).NE.A(I,NCOL+1,1)) THEN
         WRITE(*,1)
         WRITE(*,2) I
         WRITE(*,3)
         WRITE(*,4)
         WRITE(*,*)
         WRITE(*,5)
         READ(*,*)
         STOP
        END IF
      
       END DO
      END DO
      
      WRITE(*,7) NSAMPLE
      WRITE(*,8) NCOL
      WRITE(*,*)
      WRITE(*,*)
            
      WRITE(*,6)
      WRITE(*,*)
      WRITE(*,5)
      READ(*,*)
      
    1 FORMAT ('       ')
    2 FORMAT ('   :  ',(I4),'      
     &')
    3 FORMAT ('     ')
    4 FORMAT ('   ')
    5 FORMAT ('..... ENTER   .....')
    6 FORMAT ('       ')
    7 FORMAT ('      :  ',(I4))
    8 FORMAT ('    :  ',(I4))
    
      RETURN
      END

C***********************************************************************

      SUBROUTINE PRINTE(A,ALN,NSAMPLE,NCOL,ND,MD,AF,IKOMA)

      DIMENSION A(ND,MD,4),ALN(ND,MD,4),IKOMA(501)
      CHARACTER*1 AF(10501)
      DATA NOUT,NOUT1/2,22/

      DO J=1,NCOL

C     PRINT LABEL
      IF(J.EQ.1) WRITE (NOUT,100) (AF(K),K=1,IKOMA(J)-1)
      IF(J.EQ.1) WRITE (NOUT1,100) (AF(K),K=1,IKOMA(J)-1)
      IF(J.NE.1) WRITE (NOUT,100) (AF(K),K=IKOMA(J-1)+1,IKOMA(J)-1)
      IF(J.NE.1) WRITE (NOUT1,100) (AF(K),K=IKOMA(J-1)+1,IKOMA(J)-1)

C     PRINT ROW OF MATRIX
       DO I=1,NSAMPLE
        WRITE(NOUT,*) (A(I,J,K),K=1,4)
        WRITE(NOUT1,*) (ALN(I,J,K),K=1,4)
       END DO
      END DO

  100 FORMAT (20A1)

      RETURN
      END

C***********************************************************************

      SUBROUTINE PRINTF(AF,FF,NCOL,IKOMA)

      DIMENSION IKOMA(501)
      CHARACTER*1 AF(10501),FF(20),E1(5),E2(5)

      E1(1)='X'
      E1(2)='.'
      E1(3)='T'
      E1(4)='X'
      E1(5)='T'

      E2(1)='P'
      E2(2)='.'
      E2(3)='D'
      E2(4)='A'
      E2(5)='T'
      
      OPEN(1,FILE='FILETP.CTL')
      
      DO J=1,NCOL
       IF(J.EQ.1) THEN
        NC=0
        DO I=1,IKOMA(J)-1
         IF(AF(I).EQ.'"'.OR.AF(I).EQ.' ') GO TO 10
         IF(AF(I).EQ.','.OR.AF(I).EQ.'<') GO TO 10
         IF(AF(I).EQ.'.'.OR.AF(I).EQ.'>') GO TO 10
         IF(AF(I).EQ.'/'.OR.AF(I).EQ.'?') GO TO 10
         IF(AF(I).EQ.';'.OR.AF(I).EQ.':') GO TO 10
         IF(AF(I).EQ.'\'.OR.AF(I).EQ.'|') GO TO 10
         IF(AF(I).EQ.'['.OR.AF(I).EQ.'{') GO TO 10
         IF(AF(I).EQ.']'.OR.AF(I).EQ.'}') GO TO 10
         IF(AF(I).EQ.'='.OR.AF(I).EQ.'+') GO TO 10
         IF(AF(I).EQ.'-'.OR.AF(I).EQ.'_') GO TO 10
         IF(AF(I).EQ.')'.OR.AF(I).EQ.'(') GO TO 10
         IF(AF(I).EQ.'*'.OR.AF(I).EQ.'&') GO TO 10
         IF(AF(I).EQ.'^'.OR.AF(I).EQ.'%') GO TO 10
         IF(AF(I).EQ.'$'.OR.AF(I).EQ.'#') GO TO 10
         IF(AF(I).EQ.'@'.OR.AF(I).EQ.'!') GO TO 10
         NC=NC+1
         FF(NC)=AF(I)
   10   END DO 
        WRITE(1,'(20A1,5A1)') (FF(K),K=1,NC),(E1(N),N=1,5)
        WRITE(1,'(20A1,5A1)') (FF(K),K=1,NC),(E2(N),N=1,5)
       END IF

       IF(J.NE.1) THEN
        NC=0
        DO I=IKOMA(J-1)+1,IKOMA(J)-1
         IF(AF(I).EQ.'"'.OR.AF(I).EQ.' ') GO TO 20
         IF(AF(I).EQ.','.OR.AF(I).EQ.'<') GO TO 20
         IF(AF(I).EQ.'.'.OR.AF(I).EQ.'>') GO TO 20
         IF(AF(I).EQ.'/'.OR.AF(I).EQ.'?') GO TO 20
         IF(AF(I).EQ.';'.OR.AF(I).EQ.':') GO TO 20
         IF(AF(I).EQ.'\'.OR.AF(I).EQ.'|') GO TO 20
         IF(AF(I).EQ.'['.OR.AF(I).EQ.'{') GO TO 20
         IF(AF(I).EQ.']'.OR.AF(I).EQ.'}') GO TO 20
         IF(AF(I).EQ.'='.OR.AF(I).EQ.'+') GO TO 20
         IF(AF(I).EQ.'-'.OR.AF(I).EQ.'_') GO TO 20
         IF(AF(I).EQ.')'.OR.AF(I).EQ.'(') GO TO 20
         IF(AF(I).EQ.'*'.OR.AF(I).EQ.'&') GO TO 20
         IF(AF(I).EQ.'^'.OR.AF(I).EQ.'%') GO TO 20
         IF(AF(I).EQ.'$'.OR.AF(I).EQ.'#') GO TO 20
         IF(AF(I).EQ.'@'.OR.AF(I).EQ.'!') GO TO 20
         NC=NC+1
         FF(NC)=AF(I)
   20   END DO 
        WRITE(1,'(20A1,5A1)') (FF(K),K=1,NC),(E1(N),N=1,5)
        WRITE(1,'(20A1,5A1)') (FF(K),K=1,NC),(E2(N),N=1,5)
       END IF
      END DO
      
      CLOSE (1)
      
      RETURN
      END
C***********************************************************************
